{% extends 'admin/adminbase.html.twig' %}
{% import "macros/datatable.html.twig" as dt %}
{% import "macros/genLoading.html.twig" as ld %}


{% block moreCss %}
    <link href="{{ asset('dropify/css/dropify.css') }}" rel="stylesheet">

{% endblock %}

{% block body %}
    <div class="card-genossys">
        <h5>Subject</h5>
        <div class="pb-5">
            <div class="float-right">
                <a class="btn btn-primary" onclick="modalAdd()" href="#!">Tambah Subject</a>
            </div>
        </div>
        {{ dt.datatable }}
    </div>

    <div class="p-3">

    </div>

    <div class="modal fade" id="modal" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered" role="document">
            <div class="modal-content">
                <form id="formCategori">
                    <input id="id" name="id" hidden>
                    <input id="action" name="action" hidden>
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLongTitle">Form Subjek</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <div class="form-group">
                            <label for="subjek">Nama Mapel : </label>
                            <input type="text" class="form-control" id="name" name="name" placeholder="Nama Mapel">
                        </div>
                        <fieldset class="form-group">
                            <label for="subjek">Pengatudan Lanjutan : </label>

                            <div class="row">
                                <div class="col col-md-4">
                                    <div class="form-check">
                                        <input class="form-check-input checktext" type="checkbox" value="1" id="isReference" name="isReference">
                                        <label class="form-check-label" for="isReference">
                                            Referensi
                                        </label>
                                    </div>
                                </div>
                                <div class="col col-md-4">
                                    <div class="form-check">
                                        <input class="form-check-input checktext" type="checkbox" value="1" id="isDefault" name="isDefault">
                                        <label class="form-check-label" for="isDefault">
                                            Default
                                        </label>
                                    </div>
                                </div>
                                <div class="col col-md-4">
                                    <div class="form-check">
                                        <input class="form-check-input checktext" type="checkbox" value="1" id="isPopular" name="isPopular">
                                        <label class="form-check-label" for="isPopular">
                                            Populer
                                        </label>
                                    </div>
                                </div>
                            </div>
                        </fieldset>
                        <div class="form-group">
                            <label for="subjek">Icon : </label>
                            <div class="input-field" id="div-img">
                                <input type="file" onchange="" id="icon" class="icon" data-min-height="10"
                                       data-height="150"
                                       accept="image/jpeg, image/jpg, image/png"
                                       data-allowed-file-extensions="jpg jpeg png"
                                />
                            </div>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                        <button type="submit" class="btn btn-primary">Simpan</button>
                    </div>

                </form>
            </div>
        </div>
    </div>
    {{ ld.modal_loading() }}
{% endblock %}

{% block javascripts %}
    <script src="{{ asset('dropify/js/dropify.js') }}"></script>
    <script type="text/javascript"
            src="https://cdn.jsdelivr.net/npm/browser-image-compression@latest/dist/browser-image-compression.js"></script>

    <script>
        $(document).ready(function () {
            var fr = $('#formCategori');
            fr.submit(async function (e) {
                e.preventDefault(e);
                var formData = new FormData(this);

                alertify.confirm("Tambah Data Subject", "Apakah data yang anda masukkan sudah benar ?",
                    async function () {
                        $('#loading').modal();

                        if ($('#modal #icon').val()) {
                            let icon = await handleImageUpload($('#icon'));

                            formData.append('icon', icon, icon.name);
                        }
                        console.log(formData);

                        $.ajax({
                            {#url:"{{ path('mapel') }}",#}
                            type: "POST",
                            success: function (data) {
                                $('#loading').modal('hide');
                                $('#modal').modal('hide');
                                $('#tableData').DataTable().ajax.reload();

                            },
                            error: function (error) {
                                console.log("LOG ERROR", error);
                                // handle error
                            },
                            async: true,
                            data: formData,
                            cache: false,
                            contentType: false,
                            processData: false,
                            timeout: 60000
                        })
                    }, function () {

                    }
                )

            });

        });

        function modalAdd() {
            $('#modal #id').val('');
            $('#modal #action').val('add');
            $('#modal #name').val('');
            $('#modal #icon').attr('required', '');
            $('.form-check input').prop('checked', false);
            var icon = $('.icon').dropify({
                defaultFile: '',
                messages: {
                    'default': 'Masukkan Gambar Icon',
                    'replace': 'Drag and drop or click to replace',
                    'remove': 'Remove',
                    'error': 'Ooops, something wrong happended.'
                }
            });
            icon = icon.data('dropify');
            icon.resetPreview();
            icon.clearElement();

            $('#modal').modal();
        }

        $(document).on('click', 'a#editData', function () {
            var isDefault = $(this).data('isdefault');
            var isPopular = $(this).data('ispopular');
            var isReference = $(this).data('isreference');
            $('#modal #id').val($(this).data('id'));
            $('#modal #action').val('edit');
            $('#modal #name').val($(this).data('name'));
            $('#modal #icon').removeAttr('required');

            $('.checktext').prop("checked", false);

            if (isDefault) {
                $('#isDefault').prop("checked", true);
            }
            if (isPopular) {
                $('#isPopular').prop("checked", true);
            }
            if (isReference) {
                $('#isReference').prop("checked", true);
            }
            var icon = $('.icon').dropify({
                defaultFile: '',
                messages: {
                    'default': 'Masukkan Gambar Icon',
                    'replace': 'Drag and drop or click to replace',
                    'remove': 'Remove',
                    'error': 'Ooops, something wrong happended.'
                }
            });
            icon = icon.data('dropify');
            icon.resetPreview();
            icon.clearElement();
            icon.settings.defaultFile = $(this).data('icon');
            icon.destroy();
            icon.init();
            $('#modal').modal();
        });

        function loading() {

        }


    </script>
    {{ dt.datatableJS(class, space, tableAction, tableFields,where) }}
{% endblock %}